import junit.framework.TestCase;


public class PiCalculatorTest extends TestCase {

   public void testPiCalculator() {
      PiCalculator pic = new StubCalculator();
      
      // calculate pi using 1 million samples and 1 thread
      double estimate = pic.calculate(1000000,1);
      
      System.out.println ("PI estimate: " + estimate);
      double delta = estimate - Math.PI;
      
      // make sure our estimate is approximately correct
      assertTrue (Math.abs(delta) < .01);
      
      
      // Test multithreaded version
      
      // calculate pi using 1 million samples and 10 threads
      estimate = pic.calculate(1000000,10);
      
      System.out.println ("PI estimate: " + estimate);
      delta = estimate - Math.PI;
      
      // make sure our estimate is approximately correct
      assertTrue (Math.abs(delta) < .01);
   }
}
